			/* TIFF tags definitions */

#define TT_NewSubfileType 		254
#define TT_SubfileType 			255
#define TT_ImageWidth 			256 
#define TT_ImageLength 			257 
#define TT_BitsPerSample 		258 
#define TT_Compression 			259 
#define TT_PhotometricInterpretation 262 
#define TT_Threshholding 		263 
#define TT_CellWidth 			264 
#define TT_CellLength 			265 
#define TT_FillOrder 			266 
#define TT_DocumentName 		269 
#define TT_ImageDescription 	270
#define TT_Make 				271 
#define TT_Model 				272 
#define TT_StripOffsets 		273 
#define TT_Orientation 			274
#define TT_SamplesPerPixel 		277 
#define TT_RowsPerStrip 		278 
#define TT_StripByteCounts 		279 
#define TT_MinSampleValue 		280 
#define TT_MaxSampleValue 		281 
#define TT_XResolution 			282 
#define TT_YResolution 			283 
#define TT_PlanarConfiguration 	284 
#define TT_PageName 			285 
#define TT_XPosition 			286 
#define TT_YPosition 			287 
#define TT_FreeOffsets 			288 
#define TT_FreeByteCounts 		289 
#define TT_GrayResponseUnit 	290
#define TT_GrayResponseCurve 	291
#define TT_Group3Options 		292 
#define TT_Group4Options 		293 
#define TT_ResolutionUnit 		296
#define TT_PageNumber 			297 
#define TT_ColorResponseCurves 	301
#define TT_Software 			305 
#define TT_DateTime 			306 
#define TT_Artist 				315 
#define TT_HostComputer 		316 
#define TT_Predictor 			317
#define TT_WhitePoint 			318
#define TT_PrimaryChromaticities 319
#define TT_ColorMap 			320

#define TT_InkSet				332
#define TT_InkNames				333
#define TT_TargetPrinter		337

#define TT_JPEGProc						512
#define TT_JPEGInterchangeFormat		513
#define TT_JPEGInterchangeFormatLength	514
#define TT_JPEGLosslessPredictors		517
#define TT_JPEGQTables					519
#define TT_JPEGDCTables					520
#define TT_JPEGACTables					521

#define TT_YCbCrCoefficents				523
#define TT_YCbCrSubSampling				524
#define TT_YCbCrPositioning				525

/* TIFF tag type */

#define TT_BYTE			1
#define TT_ASCII		2
#define TT_SHORT		3
#define TT_LONG			4
#define TT_RATIONAL 	5
#define TT_SBYTE		6
#define TT_UNDEFINED	7
#define TT_SSHORT		8
#define TT_SLONG		9
#define TT_SRATIONAL   10
#define TT_FLOAT	   11
#define TT_DOUBLE	   12

/* TIFF tag structure */

typedef struct TTI {
	unsigned short	Tag;
	unsigned short	Type;
	unsigned long	Count;
	union {
			unsigned long LValue;
			unsigned short SValue[2];
			unsigned char CValue[4];
			};
	} TIFFTagItem;

#define	TTISIZE	(sizeof (struct TTI))

